#include <bits/stdc++.h>
#define mp make_pair
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define xx first
#define yy second
#define ff(i,s,f) for(int i=s;i<f;i++)
#define fb(i,s,f) for(int i=(s)-1;i>=f;i--)
#define ffi(i,s,f) for(int i=s;i<=f;i++)
#define fbi(i,s,f) for(int i=s;i>=f;i--)
#define srt(a) sort(a.begin(),a.end());
#define srtg(a,int) sort(a.begin(),a.end(),greater<int>())
#define lb(a,x) lower_bound(a.begin(),a.end(),x)
#define ub(a,x) upper_bound(a.begin(),a.end(),x)
#define fnd(a,x) find(a.begin(),a.end(),x)
#define vstart auto startt=chrono::system_clock::now()
#define vend auto endd=chrono::system_clock::now()
#define vvreme chrono::duration<double> vremee=endd-startt
#define ios ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef string str;

const int maxn=3010;

int dp[maxn][maxn];

void solve(){
	string s;
	cin>>s;
	for(int i=0;i<s.size();i++){
        for(int j=i+1;j>=1;j--){
            dp[i][j]=max(dp[i][j],dp[i][j+1]);
        }
        int nr=i+1,sr=i,isti=0,naj=-1;
        for(;nr<s.size();nr++){
            if(sr>=0){
                if(s[sr]==s[nr]) isti++;
                naj=max(naj,dp[i][i-sr+1]+isti);
                sr--;
            }
            dp[nr][nr-i]=max(dp[nr][nr-i],naj);
        }
	}
	cout<<dp[s.size()-1][1];
}

int main(){
    ios;
    int t=1;
    //cin>>t;
    while(t--) solve();
    return 0;
}